=== debian/changelog ===
rocm-compilersupport (5.1.0-2) unstable; urgency=medium

  * Removed 0005-cmake-exports-continued.patch.
  * Removed 0004-Relocate-cmake-export.patch.
  * Added 0004-dynamic-package-prefix.patch.
    Thanks to Cordell Bloor  (Closes: #1010649)
  * d/control: add myself to uploaders.

 -- Étienne Mollier <emollier@debian.org>  Mon, 09 May 2022 23:45:28 +0200

rocm-compilersupport (5.1.0-1) unstable; urgency=medium

  * New upstream version 5.1.0
  * Bump ROCm B-D requirement to (>= 5.1.0~).
  * Not-install duplicated license file.

 -- Mo Zhou <lumin@debian.org>  Fri, 08 Apr 2022 10:13:01 -0400

rocm-compilersupport (5.0.0-1) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Sun, 20 Mar 2022 17:28:59 -0400

rocm-compilersupport (5.0.0-1~exp1) experimental; urgency=medium

  * Initial release.

 -- Maxime Chambonnet <maxzor@maxzor.eu>  Fri, 11 Feb 2022 06:15:50 +0100
