=== debian/control ===
Source: rocm-compilersupport
Section: devel
Homepage: https://github.com/radeonopencompute/rocm-compilersupport
Priority: optional
Standards-Version: 4.6.0
Vcs-Git: https://salsa.debian.org/rocm-team/rocm-compilersupport.git
Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-compilersupport
Maintainer: ROCm Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Maxime Chambonnet <maxzor@maxzor.eu>,
           Étienne Mollier <emollier@debian.org>
Build-Depends: debhelper-compat (= 13),
               cmake,
               clang-14,
               libclang-14-dev,
               lld-14,
               liblld-14-dev,
               llvm-14-dev,
               rocm-device-libs (>= 5.1.0~),
               zlib1g-dev,
               libxml2-dev,

Package: libamd-comgr2
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: ROCm code object manager
 The Code Object Manager is a shared library which provides operations for
 creating and inspecting LLVM code objects. See the documentation in the
 header file /usr/include/amd_comgr.h .

Package: libamd-comgr-dev
Section: libdevel
Architecture: any
Depends: libamd-comgr2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: ROCm code object manager - development package
 The Code Object Manager is a shared library which provides operations for
 creating and inspecting LLVM code objects. See the documentation in the
 header file /usr/include/amd_comgr.h .
 .
 This package contains the development files.
