=== debian/changelog ===
rocm-compilersupport (5.2.3-2) unstable; urgency=medium

  * 0007-remove-h-option.patch: add; fix blender crash with cycles.
    Thanks to Jakub Jaszewski
  * d/control: declare compliance to standards version 4.6.2.
  * d/copyright: update copyright year.
  * d/salsa-ci.yml: don't test on i386; not a ROCm target.

 -- Étienne Mollier <emollier@debian.org>  Sun, 08 Jan 2023 18:20:21 +0100

rocm-compilersupport (5.2.3-1) unstable; urgency=medium

  * Migrate ROCm 5.2.3 to unstable.
  * d/control: build depend on ROCm 5.2 packages.
  * d/control: bump build dependency to llvm 15.
  * d/control: add missing llvm packages following layout change.
  * 0005-llvm14-missing-gfx1036.patch: remove.
    This patch is not necessary anymore once bumping to llvm-15.
  * 0001-find-LLD-cmake-patch.patch: adjust for llvm 15.
  * 0005-dbg-compression-type.patch: add; fix ftbfs with llvm 15.
  * 0006-TargetRegistry.patch: add; fix ftbfs with llvm 15.

 -- Étienne Mollier <emollier@debian.org>  Wed, 19 Oct 2022 14:05:51 +0200

rocm-compilersupport (5.2.3-1~0exp0) experimental; urgency=medium

  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Apply multi-arch hints.
    + libamd-comgr2: Add Multi-Arch: same.
  * 0002-fix-optional-templating.patch: unfuzz.
  * 0003-comgr-compiler-linkwithlld.patch: remove; applied upstream.
  * 0004-dynamic-package-prefix.patch: refresh.
  * 0005-llvm14-missing-gfx1036.patch: added; fix ftbfs with llvm-14.
    Thanks to Jeremy Newton

 -- Étienne Mollier <emollier@debian.org>  Tue, 06 Sep 2022 21:09:54 +0200
