=== debian/control ===
Source: rocm-compilersupport
Maintainer: ROCm Team <debian-ai@lists.debian.org>
Uploaders: Mo Zhou <lumin@debian.org>,
           Norbert Preining <norbert@preining.info>,
           Maxime Chambonnet <maxzor@maxzor.eu>,
           Étienne Mollier <emollier@debian.org>
Section: devel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               clang-15,
               clangd-15,
               clang-format-15,
               clang-tidy-15,
               clang-tools-15,
               libclang-15-dev,
               libmlir-15-dev,
               lld-15,
               liblld-15-dev,
               llvm-15-dev,
               mlir-15-tools,
               rocm-device-libs (>= 5.2.0~),
               zlib1g-dev,
               libxml2-dev
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/rocm-team/rocm-compilersupport
Vcs-Git: https://salsa.debian.org/rocm-team/rocm-compilersupport.git
Homepage: https://github.com/radeonopencompute/rocm-compilersupport
Rules-Requires-Root: no

Package: libamd-comgr2
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Multi-Arch: same
Description: ROCm code object manager
 The Code Object Manager is a shared library which provides operations for
 creating and inspecting LLVM code objects. See the documentation in the
 header file /usr/include/amd_comgr.h .

Package: libamd-comgr-dev
Architecture: any
Section: libdevel
Depends: libamd-comgr2 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: ROCm code object manager - development package
 The Code Object Manager is a shared library which provides operations for
 creating and inspecting LLVM code objects. See the documentation in the
 header file /usr/include/amd_comgr.h .
 .
 This package contains the development files.
