=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DEV_BIN_PKG=libamd-comgr-dev
%:
	dh $@ -Dlib/comgr -Scmake

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/$(DEV_BIN_PKG)/usr/share/doc/$(DEV_BIN_PKG)
	rm -f debian/tmp/usr/share/amd_comgr/LICENSE.txt
	mv debian/tmp/usr/share/amd_comgr/* debian/$(DEV_BIN_PKG)/usr/share/doc/$(DEV_BIN_PKG)
	rmdir  debian/tmp/usr/share/amd_comgr

override_dh_auto_test:
	# TODO build and test
	:
