=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocm-comgr-$1.tar.gz%" \
https://github.com/RadeonOpenCompute/ROCm-CompilerSupport/tags \
(?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz debian
