=== debian/changelog ===
rocm-compilersupport (6.0+git20231212.4510c28+dfsg-3build3) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 21 May 2025 08:17:01 +0200

rocm-compilersupport (6.0+git20231212.4510c28+dfsg-3build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:58:33 +1100

rocm-compilersupport (6.0+git20231212.4510c28+dfsg-3build1) noble; urgency=medium

  * No-change rebuild against libllvm17t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 12 Mar 2024 07:10:19 +0000

rocm-compilersupport (6.0+git20231212.4510c28+dfsg-3) unstable; urgency=medium

  * dbgsym: Disable dwz and switch to compressed DWARF-5.
    Fixes a FTBFS in Ubuntu (ppc64el).

 -- Christian Kastner <ckk@debian.org>  Sat, 02 Mar 2024 19:32:33 +0100

rocm-compilersupport (6.0+git20231212.4510c28+dfsg-2) unstable; urgency=medium

  * d/rules: Disable LTO. Fixes a FTBFS in Ubuntu.

 -- Christian Kastner <ckk@debian.org>  Thu, 29 Feb 2024 17:05:32 +0100

rocm-compilersupport (6.0+git20231212.4510c28+dfsg-1) unstable; urgency=medium

  * Migrate to unstable.
  * Add myself to Uploaders.
  * d/control: update filename in package description
  * d/control: trim build-depends

 -- Cordell Bloor <cgmb@slerp.xyz>  Sat, 24 Feb 2024 23:14:32 -0700

rocm-compilersupport (6.0+git20231212.4510c28+dfsg-1~exp2) unstable; urgency=medium

  * Add myself to Uploaders
  * Update restore-amd_comgr_get_isa_count-amd_comgr_1.8.patch.
    Add .symvers so that the symbol is exported with both old and new
    version. (Closes: #1063349)

 -- Christian Kastner <ckk@debian.org>  Thu, 08 Feb 2024 10:17:10 +0100

rocm-compilersupport (6.0+git20231212.4510c28+dfsg-1~exp1) experimental; urgency=medium

  * Team upload.

  * New upstream version 6.0+git20231212.4510c28+dfsg
  * d/watch: follow release/17.x branch
  * Update upstream URLs
  * d/control: update Build-Depends to clang-17
  * Add patch to restore original amd_comgr_get_isa_count symbol version.

 -- Cordell Bloor <cgmb@slerp.xyz>  Mon, 05 Feb 2024 15:50:32 -0700
