=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all optimize=-lto
export DEB_CXXFLAGS_MAINT_PREPEND = -gz

CMAKE_FLAGS = \
	-DCMAKE_PREFIX_PATH=/usr/lib/llvm-17 \
	-DBUILD_TESTING=OFF \
	-DBUILD_FILE_REORG_BACKWARD_COMPATIBILITY=OFF

DEV_BIN_PKG=libamd-comgr-dev
%:
	dh $@ -Dlib/comgr -Scmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

override_dh_auto_test:
	# TODO build and test
	:

# dwz doesn't fully support DWARF-5 yet, see #1016936
override_dh_dwz:
	:
