=== debian/watch ===
version=4
opts="mode=git, pretty=6.0+git%cd.%h, dversionmangle=s/\+dfsg\d*$//, repacksuffix=+dfsg, pgpmode=none" \
	https://github.com/ROCm/ROCm-CompilerSupport \
	heads/release/17.x debian uupdate
